
#include <Nextion.h> // Need to add Nextion arduino library
//Giga heaters arduino Mega 2560 made by rarprint 17.10.2017 (Thermal protection added)

int temp = 0;  // Variable for target temperature
int CurrentPage = 0;  // Create a variable to store which page is currently loaded
const int safetime=30; // constant variable for thermal protection/ time period to heat target temperature

int tempsensor1 = 0;
int tempsensor2 = 0;
int tempsensor3 = 0;
int tempsensor4 = 0;
int tempsensor5 = 0;
int tempsensor6 = 0;
int tempsensor7 = 0;
int tempsensor8 = 0;
int tempsensor9 = 0;
int tempsensor10 = 0;
int tempsensor11 = 0;
int tempsensor12 = 0; //Variables for temperature from temperature sensors

int heat1=0;
int heat2=0;
int heat3=0;
int heat4=0;
int heat5=0;
int heat6=0;
int heat7=0;
int heat8=0;
int heat9=0;
int heat10=0;
int heat11=0;
int heat12=0;// Variables for heat button statement ON or OFF

int time1=0;
int time2=0;
int time3=0;
int time4=0;
int time5=0;
int time6=0;
int time7=0;
int time8=0;
int time9=0;
int time10=0;
int time11=0;
int time12=0;// Variables for time count when heating is on

// Declare objects that we are going to read from the display. This includes buttons, sliders, text boxes, etc:
// Format: <type of object> <object name> = <type of object>(<page id>, <object id>, "<object name>");

NexDSButton bt0 = NexDSButton(0, 1, "bt0");  // Dual state button added
NexDSButton bt1 = NexDSButton(0, 6, "bt1");  // Dual state button added
NexDSButton bt2 = NexDSButton(0, 7, "bt2");  // Dual state button added
NexDSButton bt3 = NexDSButton(0, 8, "bt3");  // Dual state button added
NexDSButton bt4 = NexDSButton(0, 9, "bt4");  // Dual state button added
NexDSButton bt5 = NexDSButton(0, 10,"bt5");  // Dual state button added
NexDSButton bt6 = NexDSButton(0, 11, "bt6");  // Dual state button added
NexDSButton bt7 = NexDSButton(0, 12, "bt7");  // Dual state button added
NexDSButton bt8 = NexDSButton(0, 13, "bt8");  // Dual state button added
NexDSButton bt9 = NexDSButton(0, 14, "bt9");  // Dual state button added
NexDSButton bt10 = NexDSButton(0, 15, "bt10");  // Dual state button added
NexDSButton bt11 = NexDSButton(0, 16, "bt11");  // Dual state button added
//NexNumber n0 = NexNumber(0,3,"n0");//Number box
NexButton b1 = NexButton(0, 4, "b1");  // Button added
NexButton b2 = NexButton(0, 5, "b2");  // Button added
// Declare pages:
// Sending data to the display to nonexistent objects on the current page creates an error code sent by the display.
// Any error sent by the display creates lag on the arduino loop because arduino tries to read it, thinking it's a touch event.
// So to avoid this, I am only going to send data depending on the page the display is on.
// That's the reason I want the arduino to know which page is loaded on the display.
// To let arduino know what page is currently loaded, we are creating a touch event for each page.
// On the nextion project, each page most send a simulated "Touch Press Event" in the "Preinitialize Event" section so
// we can register that a new page was loaded.
NexPage page0 = NexPage(0, 0, "page0");  // Page added as a touch event


// End of declaring objects


char buffer[100] = {0};  // This is needed only if you are going to receive a text from the display. You can remove it otherwise.
                         // Further on this sketch I do receive text so that's why I created this buffer.







// Declare touch event objects to the touch event list: 
// You just need to add the names of the objects that send a touch event.
// Format: &<object name>,

NexTouch *nex_listen_list[] = 
{
  &bt0,  // Button added
  &bt1,  // Button added
  &bt2,  // Button added
  &bt3,  // Button added
  &bt4,  // Button added
  &bt5,  // Button added
  &bt6,  // Button added
  &bt7,  // Button added
  &bt8,  // Button added
  &bt9,  // Button added
  &bt10,  // Button added
  &bt11,  // Button added
  &b1,  // Button added
  &b2,  // Button added
  
  &page0,  // Page added as a touch event
   NULL  // String terminated
};  // End of touch event list




//void n0PopCallback(void *ptr);

////////////////////////// Touch events:
// Each of the following sections are going to run everytime the touch event happens:
// Is going to run the code inside each section only ones for each touch event.
void bt0PopCallback(void *ptr)  // Release event for dual state button bt0
{
  
  uint32_t number0 = 0;  // Create variable to store value we are going to get
  bt0.getValue(&number0);  // Read value of dual state button to know the state (0 or 1)

  if (number0==1){  // If dual state button is equal to 1 (meaning is ON)...
    heat1=1;
   }else {
    heat1=0;
   }
   return heat1;
   
}  // End of release event
////////////////////////// BUTTON 2
 void bt1PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number1 = 0;  // Create variable to store value we are going to get
  bt1.getValue(&number1);  // Read value of dual state button to know the state (0 or 1)

  if (number1==1){  // If dual state button is equal to 1 (meaning is ON)...
   heat2=1;
   }else{
    heat2=0;
  }
  return heat2;
}  // End of release event
 ////////////////////////// BUTTON 3
void bt2PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number2 = 0;  // Create variable to store value we are going to get
  bt2.getValue(&number2);  // Read value of dual state button to know the state (0 or 1)

  if(number2 == 1){  // If dual state button is equal to 1 (meaning is ON)...
   heat3=1;
   }
    
  else  {
   heat3=0;
  }
  return heat3;
}  // End of release event 

////////////////////////// BUTTON 4
 void bt3PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number3 = 0;  // Create variable to store value we are going to get
  bt3.getValue(&number3);  // Read value of dual state button to know the state (0 or 1)

  if(number3 == 1){  // If dual state button is equal to 1 (meaning is ON)...
    heat4=1;
   }
    
  else  {
   heat4=0;
  }
  return heat4;
}  // End of release event
////////////////////////// BUTTON 5
void bt4PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number4 = 0;  // Create variable to store value we are going to get
  bt4.getValue(&number4);  // Read value of dual state button to know the state (0 or 1)

  if(number4 == 1){  // If dual state button is equal to 1 (meaning is ON)...
    heat5=1;
   }
    
  else  {
   heat5=0;
  }
  return heat5;
}  // End of release event

////////////////////////// BUTTON 6
void bt5PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number5 = 0;  // Create variable to store value we are going to get
  bt5.getValue(&number5);  // Read value of dual state button to know the state (0 or 1)

  if(number5 == 1){  // If dual state button is equal to 1 (meaning is ON)...
   heat6=1;
   }
    
  else  {
   heat6=0;
  }
  return heat6;
}  // End of release event

////////////////////////// BUTTON 7

void bt6PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number6 = 0;  // Create variable to store value we are going to get
  bt6.getValue(&number6);  // Read value of dual state button to know the state (0 or 1)

  if(number6 == 1){  // If dual state button is equal to 1 (meaning is ON)...
   heat7=1;
   }
    
  else  {
   heat7=0;
  }
  return heat7;
}  // End of release event

////////////////////////// BUTTON 8
void bt7PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number7 = 0;  // Create variable to store value we are going to get
  bt7.getValue(&number7);  // Read value of dual state button to know the state (0 or 1)

  if(number7 == 1){  // If dual state button is equal to 1 (meaning is ON)...
    heat8=1;
   }
    
  else  {
   heat8=0;
  }
  return heat8;
}  // End of release event


////////////////////////// BUTTON 9
void bt8PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number8 = 0;  // Create variable to store value we are going to get
  bt8.getValue(&number8);  // Read value of dual state button to know the state (0 or 1)

  if(number8 == 1){  // If dual state button is equal to 1 (meaning is ON)...
    heat9=1;
   }
    
  else  {
   heat9=0;
  }
  return heat9;
}  // End of release event

////////////////////////// BUTTON 10
void bt9PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number9 = 0;  // Create variable to store value we are going to get
  bt9.getValue(&number9);  // Read value of dual state button to know the state (0 or 1)

  if(number9 == 1){  // If dual state button is equal to 1 (meaning is ON)...
  heat10=1;
   }
    
  else  {
   heat10=0;
  }
  return heat10;
}  // End of release event

////////////////////////// BUTTON 11
void bt10PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number10 = 0;  // Create variable to store value we are going to get
  bt10.getValue(&number10);  // Read value of dual state button to know the state (0 or 1)

  if(number10 == 1){  // If dual state button is equal to 1 (meaning is ON)...
  heat11=1;
   }
    
  else  {
   heat11=0;
  }
  return heat11;
}  // End of release event

////////////////////////// BUTTON 12
void bt11PopCallback(void *ptr)  // Release event for dual state button bt0
{
  uint32_t number11 = 0;  // Create variable to store value we are going to get
  bt11.getValue(&number11);  // Read value of dual state button to know the state (0 or 1)

  if(number11 == 1){  // If dual state button is equal to 1 (meaning is ON)...
    heat12=1;
   }
    
  else  {
   heat12=0;
  }
  return heat12;
}  
// End of release event
// Page change event:
void page0PushCallback(void *ptr)  // If page 0 is loaded on the display, the following is going to execute:
{
  CurrentPage = 0;  // Set variable as 0 so from now on arduino knows page 0 is loaded on the display
}  // End of press event

void b1PushCallback(void *ptr)  // Press event for button b1
{
  temp = temp + 10;  // Add 10 to the current value of the temp counter

  Serial2.print("n0.val=");  // This is sent to the nextion display to set what object name (before the dot) and what atribute (after the dot) are you going to change.
  Serial2.print(temp);  // This is the value you want to send to that object and atribute mentioned before.
  Serial2.write(0xff);  // We always have to send this three lines after each command sent to the nextion display.
  Serial2.write(0xff);
  Serial2.write(0xff);
}  // End of release event


void b2PushCallback(void *ptr)  // Release event for button b2
{
  temp = temp - 10;  // Substract 10 to the current value of the temp counter

  Serial2.print("n0.val=");  // This is sent to the nextion display to set what object name (before the dot) and what atribute (after the dot) are you going to change.
  Serial2.print(temp);  // This is the value you want to send to that object and atribute mentioned before.
  Serial2.write(0xff);  // We always have to send this three lines after each command sent to the nextion display.
  Serial2.write(0xff);
  Serial2.write(0xff);
}  // End of release event

// which analog pin to connect
#define THERMISTORPIN A0   
#define THERMISTORPIN1 A1
#define THERMISTORPIN2 A2
#define THERMISTORPIN3 A3
#define THERMISTORPIN4 A5
#define THERMISTORPIN5 A7
#define THERMISTORPIN6 A8
#define THERMISTORPIN7 A10
#define THERMISTORPIN8 A12
#define THERMISTORPIN9 A13
#define THERMISTORPIN10 A14
#define THERMISTORPIN11 A15   // Pins for thermistors NTC 100k
    
// resistance at 25 degrees C
#define THERMISTORNOMINAL 100000      
// temp. for nominal resistance (almost always 25 C)
#define TEMPERATURENOMINAL 25   
// how many samples to take and average, more takes longer
// but is more 'smooth'
#define NUMSAMPLES 5

// The beta coefficient of the thermistor (usually 3000-4000)
#define BCOEFFICIENT 3950
// the value of the 'other' resistor
#define SERIESRESISTOR 3200   
 
uint16_t samples[NUMSAMPLES];



void setup() {
  // put your setup code here, to run once:
 pinMode (6,OUTPUT);
 pinMode (7,OUTPUT);
 pinMode (8,OUTPUT);
 pinMode (9,OUTPUT);
 pinMode (10,OUTPUT);
 pinMode (11,OUTPUT);
 pinMode (13,OUTPUT);
 pinMode (12,OUTPUT);
 pinMode (5,OUTPUT);
 pinMode (4,OUTPUT);
 pinMode (3,OUTPUT);
 pinMode (2,OUTPUT); //pinMode need to be declared to obtain 5 voltage output
  
  //Serial.begin(9600);
  Serial2.begin(9600);  // Start serial comunication at baud=9600


  // I am going to change the Serial baud to a faster rate.
  // The reason is that the slider have a glitch when we try to read it's value.
  // One way to solve it was to increase the speed of the serial port.
  delay(500);  // This dalay is just in case the nextion display didn't start yet, to be sure it will receive the following command.
  Serial2.print("baud=115200");  // Set new baud rate of nextion to 115200, but it's temporal. Next time nextion is power on,
                                // it will retore to default baud of 9600.
                                // To take effect, make sure to reboot the arduino (reseting arduino is not enough).
                                // If you want to change the default baud, send the command as "bauds=115200", instead of "baud=115200".
                                // If you change the default baud, everytime the nextion is power ON is going to have that baud rate, and
                                // would not be necessery to set the baud on the setup anymore.
  Serial2.write(0xff);  // We always have to send this three lines after each command sent to nextion.
  Serial2.write(0xff);
  Serial2.write(0xff);

  Serial2.end();  // End the serial comunication of baud=9600

  Serial2.begin(115200);  // Start serial comunication at baud=115200
 


// Register the event callback functions of each touch event:
  // You need to register press events and release events seperatly.
  // Format for press events: <object name>.attachPush(<object name>PushCallback);
  // Format for release events: <object name>.attachPop(<object name>PopCallback);
  bt0.attachPop(bt0PopCallback); 
  bt1.attachPop(bt1PopCallback);
  bt2.attachPop(bt2PopCallback);
  bt3.attachPop(bt3PopCallback);
  bt4.attachPop(bt4PopCallback);
  bt5.attachPop(bt5PopCallback);
  bt6.attachPop(bt6PopCallback);
  bt7.attachPop(bt7PopCallback);
  bt8.attachPop(bt8PopCallback);
  bt9.attachPop(bt9PopCallback);
  bt10.attachPop(bt10PopCallback);
  bt11.attachPop(bt11PopCallback);
 
  page0.attachPush(page0PushCallback);  // Page press event
  b1.attachPush(b1PushCallback);  // Button press
  b2.attachPush(b2PushCallback);  // Button press
  
  // End of registering the event callback functions

  
}





void loop(void) {
  // put your main code here, to run repeatedly:
uint8_t i;
  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN); // Temp sensor 1
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
   
   tempsensor1 = steinhart ;
  Serial2.print("bt0.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor1); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();
  if (tempsensor1<=temp&&heat1==1) {
    digitalWrite(6, HIGH);
    time1++;
   }
  if (tempsensor1>=temp&&heat1==1){
    digitalWrite(6, LOW);
    time1=0;
   }
   if (heat1==0){
    digitalWrite(6, LOW);
    time1=0;
   }

   //thermal protection
   if (tempsensor1<=temp&&heat1==1&&time1>safetime){
    digitalWrite(6, LOW);
   
   Serial2.print("bt0.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor1<=0){
   digitalWrite(6, LOW);
   
   Serial2.print("bt0.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
delay(10);

steinhart = 0;
 // second temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN1); //Temp sensor 2
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor2 = steinhart ;
Serial2.print("bt1.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor2); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();

   if (tempsensor2<=temp&&heat2==1) {
    digitalWrite(7, HIGH);
    time2++;
   }
  if (tempsensor2>=temp&&heat2==1){
    digitalWrite(7, LOW);
    time2=0;
   }
   if (heat2==0){
    digitalWrite(7, LOW);
    time2=0;
   }
   //thermal protection
     if (tempsensor2<=temp&&heat2==1&&time2>safetime){
    digitalWrite(7, LOW);
   
   Serial2.print("bt1.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor2<=0){
   digitalWrite(7, LOW);
   
   Serial2.print("bt1.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
   
delay(10);

steinhart = 0;
 // Third temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN2); //Temp sensor 3
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor3 = steinhart ;
Serial2.print("bt2.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor3); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();
  if (tempsensor3<=temp&&heat3==1) {
    digitalWrite(8, HIGH);
    time3++;
   }
  if (tempsensor3>=temp&&heat3==1){
    digitalWrite(8, LOW);
    time3=0;
   }
   if (heat3==0){
    digitalWrite(8, LOW);
    time3=0;
   }
     //thermal protection
     if (tempsensor3<=temp&&heat3==1&&time3>safetime){
    digitalWrite(8, LOW);
   
   Serial2.print("bt2.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor3<=0){
   digitalWrite(8, LOW);
   
   Serial2.print("bt2.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
delay(10);

steinhart = 0;
 // Four temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN3); //Temp sensor 4
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor4 = steinhart ;
Serial2.print("bt3.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor4); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();

  
    if (tempsensor4<=temp&&heat4==1) {
    digitalWrite(9, HIGH);
    time4++;
   }
  if (tempsensor4>=temp&&heat4==1){
    digitalWrite(9, LOW);
    time4=0;
   }
   if (heat4==0){
    digitalWrite(9, LOW);
    time4=0;
   }
     //thermal protection
     if (tempsensor4<=temp&&heat4==1&&time4>safetime){
    digitalWrite(9, LOW);
   
   Serial2.print("bt3.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor4<=0){
   digitalWrite(9, LOW);
   
   Serial2.print("bt3.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
delay(10);
  
steinhart = 0;
 // Five temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN4); //Temp sensor 5
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor5 = steinhart ;
Serial2.print("bt4.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor5); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();
        if (tempsensor5<=temp&&heat5==1) {
    digitalWrite(10, HIGH);
    time5++;
   }
  if (tempsensor5>=temp&&heat5==1){
    digitalWrite(10, LOW);
    time5=0;
   }
   if (heat5==0){
    digitalWrite(10, LOW);
     time5=0;
   }
       //thermal protection
     if (tempsensor5<=temp&&heat5==1&&time5>safetime){
    digitalWrite(10, LOW);
   
   Serial2.print("bt4.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor5<=0){
   digitalWrite(10, LOW);
   
   Serial2.print("bt4.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
delay(10);

steinhart = 0;
 // Six temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN5); //Temp sensor 6
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor6 = steinhart ;
Serial2.print("bt5.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor6); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();

   if (tempsensor6<=temp&&heat6==1) {
    digitalWrite(11, HIGH);
    time6++;
   }
  if (tempsensor6>=temp&&heat6==1){
    digitalWrite(11, LOW);
    time6=0;
   }
   if (heat6==0){
    digitalWrite(11, LOW);
    time6=0;
   }
          //thermal protection
     if (tempsensor6<=temp&&heat6==1&&time6>safetime){
    digitalWrite(11, LOW);
   
   Serial2.print("bt5.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor6<=0){
   digitalWrite(11, LOW);
   
   Serial2.print("bt5.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
delay(10);

steinhart = 0;
 // Seven temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN6); //Temp sensor 7
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor7 = steinhart ;
Serial2.print("bt6.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor7); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();
   
   if (tempsensor7<=temp&&heat7==1) {
    digitalWrite(13, HIGH);
    time7++;
   }
  if (tempsensor7>=temp&&heat7==1){
    digitalWrite(13, LOW);
    time7=0;
   }
   if (heat7==0){
    digitalWrite(13, LOW);
    time7=0;
   }
             //thermal protection
     if (tempsensor7<=temp&&heat7==1&&time7>safetime){
    digitalWrite(13, LOW);
   
   Serial2.print("bt6.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor7<=0){
   digitalWrite(13, LOW);
   
   Serial2.print("bt6.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
delay(10);

steinhart = 0;
 // Eight temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN7); //Temp sensor 8
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor8 = steinhart ;
Serial2.print("bt7.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor8); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();

    if (tempsensor8<=temp&&heat8==1) {
    digitalWrite(12, HIGH);
    time8++;
   }
  if (tempsensor8>=temp&&heat8==1){
    digitalWrite(12, LOW);
    time8=0;
   }
   if (heat8==0){
    digitalWrite(12, LOW);
    time8=0;
   }

             //thermal protection
   if (tempsensor8<=temp&&heat8==1&&time8>safetime){
   digitalWrite(12, LOW);
   
   Serial2.print("bt7.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor8<=0){
   digitalWrite(12, LOW);
   
   Serial2.print("bt7.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
delay(10);

steinhart = 0;
 // Nine temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN8); //Temp sensor 9
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor9 = steinhart ;
Serial2.print("bt8.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor9); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();
  
    if (tempsensor9<=temp&&heat9==1) {
    digitalWrite(5, HIGH);
    time9++;
   }
  if (tempsensor9>=temp&&heat9==1){
    digitalWrite(5, LOW);
    time9=0;
   }
   if (heat9==0){
    digitalWrite(5, LOW);
    time9=0;
   }
   //thermal protection
     if (tempsensor9<=temp&&heat9==1&&time9>safetime){
    digitalWrite(5, LOW);
   
   Serial2.print("bt8.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor9<=0){
   digitalWrite(5, LOW);
   
   Serial2.print("bt8.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
   
delay(10);

steinhart = 0;
 // Ten temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN9); //Temp sensor 10
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor10 = steinhart ;
Serial2.print("bt9.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor10); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();

   if (tempsensor10<=temp&&heat10==1) {
    digitalWrite(4, HIGH);
    time10++;
   }
  if (tempsensor10>=temp&&heat10==1){
    digitalWrite(4, LOW);
    time10=0;
   }
   if (heat10==0){
    digitalWrite(4, LOW);
     time10=0;
   }

    //thermal protection
     if (tempsensor10<=temp&&heat10==1&&time10>safetime){
    digitalWrite(4, LOW);
   
   Serial2.print("bt9.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damaging
   if (tempsensor10<=0){
   digitalWrite(4, LOW);
   
   Serial2.print("bt9.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
delay(10);

steinhart = 0;
 // Eleven temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN10); //Temp sensor 11
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor11 = steinhart ;
Serial2.print("bt10.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor11); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();

    if (tempsensor11<=temp&&heat11==1) {
    digitalWrite(3, HIGH);
    time11++;
   }
  if (tempsensor11>=temp&&heat11==1){
    digitalWrite(3, LOW);
    time11=0;
   }
   if (heat11==0){
    digitalWrite(3, LOW);
    time11=0;
   }

      //thermal protection
   if (tempsensor11<=temp&&heat11==1&&time11>safetime){
   digitalWrite(3, LOW);
   
   Serial2.print("bt10.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor11<=0){
   digitalWrite(3, LOW);
   
   Serial2.print("bt10.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
delay(10);

steinhart = 0;
 // Twelve temp sensor 
//uint8_t i;
//  float average;
 
  // take N samples in a row, with a slight delay
  for (i=0; i< NUMSAMPLES; i++) {
   samples[i] = analogRead(THERMISTORPIN11); //Temp sensor 12
   delay(10);
  }
 
  // average all the samples out
  average = 0;
  for (i=0; i< NUMSAMPLES; i++) {
     average += samples[i];
  }
  average /= NUMSAMPLES;
 
 // Serial.print("Average analog reading "); 
 /// Serial.println(average);
 
  // convert the value to resistance
  average = 1023 / average - 1;
  average = SERIESRESISTOR / average;
  //Serial.print("Thermistor resistance "); 
 // Serial.println(average);
 
//  float steinhart;
  steinhart = average / THERMISTORNOMINAL;     // (R/Ro)
  steinhart = log(steinhart);                  // ln(R/Ro)
  steinhart /= BCOEFFICIENT;                   // 1/B * ln(R/Ro)
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart;                 // Invert
  steinhart -= 273.15;                         // convert to C
 
  //Serial.print("Temperature "); 
  //Serial.print(steinhart);
  //Serial.println(" *C");
tempsensor12 = steinhart ;
Serial2.print("bt11.txt=");
   Serial2.write(0x22);
   Serial2.println(tempsensor12); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   //Serial2.flush();

 

   if (tempsensor12<=temp&&heat12==1) {
    digitalWrite(2, HIGH);
    time12++;
   }
  if (tempsensor12>=temp&&heat12==1){
    digitalWrite(2, LOW);
    time12=0;
   }
   if (heat12==0){
    digitalWrite(2, LOW);
    time12=0;
   }
        //thermal protection
   if (tempsensor12<=temp&&heat12==1&&time12>safetime){
   digitalWrite(2, LOW);
   
   Serial2.print("bt11.txt=");
   Serial2.write(0x22);
   Serial2.println("fault"); //Remove inverts for Variable
   Serial2.write(0x22);
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
    // Safety for temp sensor damagig
   if (tempsensor12<=0){
   digitalWrite(2, LOW);
   
   Serial2.print("bt11.val=0");
   Serial2.write(0xff);
   Serial2.write(0xff);
   Serial2.write(0xff);
   }
delay(10);

//230 delay
// We are going to check the list of touch events we enter previously to
  // know if any touch event just happened, and excecute the corresponding instructions:

  nexLoop(nex_listen_list);  // Check for any touch event

}// End of loop


 


